--[[ oTravi
	Hello Mr. Localizer / Bug fixer,
	
	If you want to localize this add on, feel free to send me a diff/patch on troeks@gmail.com.
	Don't commit however, since that puts me out of control regarding changes, and it's very
	common that the add on breaks with  syntax errors or incorrectly added externals.
	
	I'm very tired of thsi happening, so the consequences of this will be that I removed the
	add on from the SVN as people think they can tinker with everything without asking.
	
	This is the final warning.
	
	(This also yields for every other type of commit that effects this add on.)
]]
local D = AceLibrary:GetInstance("Dewdrop-2.0")
local L = AceLibrary("AceLocale-2.2"):new("oTravi")
oTravi = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")

L:RegisterTranslations("enUS", function()
return {
	["Poisons"] = true,
}
end)

local table = {
	type= 'group',
	args = {
		Header = {
			name = "Buy Poisons",
			type = "header",
			order = 1,
		},
		Craft = {
			name = "Craft",
			type = "execute",
			desc = "Let's make some poison!",
			icon = "Interface\\Icons\\INV_Scroll_04",
			func = function()
				CastSpellByName(L["Poisons"])
				D:Open(MerchantFrame, 'children', function() D:FeedAceOptionsTable(oTravi:GenerateD()) end, 'point', function(parent) return "TOP", "BOTTOM" end)
			end,
			order = 999,
			closeWhenClicked = false,
		}
	}
}

local buy = function(n, q, i)
	return {
		name = string.format("Buy (+%d)", q),
		type = "execute",
		desc = string.format("Buy %dx[%s].", q, n),
		func = function()
			oTravi:Buy(i, q, 1)
		end,
		order = 100 + q,
		closeWhenClicked = false,
	}
end
local refill = function(n, q, i)
	return {
		name = string.format("Refill (=%d)", q),
		type = "execute",
		desc = string.format("Refill up to %dx[%s].  ", q, n, q),
		func = function()
			q = q - oTravi:ScanBags(i)
			oTravi:Buy(i, q, 1)
		end,
		order = 200 + q,
		closeWhenClicked = false,
	}
end

local poison = {
	[21835] = { -- Anesthetic Poison
		[8925] = 1, -- Crystal Vial
		[3777] = 4, -- Lethargy Root
		[5173] = 1, -- Deathweed
		k = "ap"
	},
	[21927] = { -- Instant Poison VII
		[8925] = 1, -- Crystal Vial
		[2931] = 1, -- Maiden's Anguish
		[8924] = 1, -- Dust of Deterioration
		k = "ip7", g = 6947
	},
	[8928] = { -- Instant Poison VI
		[8925] = 1, -- Crystal Vial
		[8924] = 4, -- Dust of Deterioration
		k = "ip6", g = 6947
	},
	[8927] = { -- Instant Poison V
		[8925] = 1, -- Crystal Vial
		[8924] = 3, -- Dust of Deterioration
		k = "ip5", g = 6947
	},
	[8926] = { -- Instant Poison IV
		[8925] = 1, -- Crystal Vial
		[8924] = 2, -- Dust of Deterioration
		k = "ip4", g = 6947
	},
	[6950] = { -- Instant Poison III
		[3372] = 1, -- Leaded Vial
		[8924] = 1, -- Dust of Deterioration
		k = "ip3", g = 6947
	},
	[6949] = { -- Instant Poison II
		[3372] = 1, -- Leaded Vial
		[2928] = 3, -- Dust of Decay
		k = "ip2", g = 6947
	},
	[6947] = { -- Instant Poison
		[3371] = 1, -- Empty Vial
		[2928] = 1, -- Dust of Decay
		k = "ip"
	},
	[22055] = { -- Wound Poison V
		[8925] = 1, -- Crystal Vial
		[8923] = 3, -- Essence of Agony
		[5173] = 3, -- Deathweed
		k = "wp5", g = 10918
	},
	[10922] = { -- Wound Poison IV
		[8925] = 1, -- Crystal Vial
		[8923] = 2, -- Essence of Agony
		[5173] = 2, -- Deathweed
		k = "wp4", g = 10918
	},
	[10921] = { -- Wound Poison III
		[8925] = 1, -- Crystal Vial
		[8923] = 1, -- Essence of Agony
		[5173] = 2, -- Deathweed
		k = "wp3", g = 10918
	},
	[10920] = { -- Wound Poison II
		[3372] = 1, -- Leaded Vial
		[2930] = 1, -- Essence of Pain
		[5173] = 2, -- Deathweed
		k = "wp2", g = 10918
	},
	[10918] = { -- Wound Poison
		[3372] = 1, -- Leaded Vial
		[2930] = 1, -- Essence of Pain
		[5173] = 1, -- Deathweed
		k = "wp"
	},
	[22054] = { -- Deadly Poison VII
		[8925] = 1, -- Crystal Vial
		[2931] = 1, -- Maiden's Anguish
		[5173] = 1, -- Deathweed
		k = "dp7", g = 2892
	},
	[22053] = { -- Deadly Poison VI
		[8925] = 1, -- Crystal Vial
		[2931] = 1, -- Maiden's Anguish
		k = "dp6", g = 2892
	},
	[20844] = { -- Deadly Poison V
		[8925] = 1, -- Crystal Vial
		[5173] = 7, -- Deathweed
		k = "dp5", g = 2892
	},
	[8985] = { -- Deadly Poison IV
		[8925] = 1, -- Crystal Vial
		[5173] = 5, -- Deathweed
		k = "dp4", g = 2892
	},
	[8984] = { -- Deadly Poison III
		[8925] = 1, -- Crystal Vial
		[5173] = 3, -- Deathweed
		k = "dp3", g = 2892
	},
	[2893] = { -- Deadly Poison II
		[3372] = 1, -- Leaded Vial
		[5173] = 2, -- Deathweed
		k = "dp2", g = 2892
	},
	[2892] = { -- Deadly Poison 
		[3372] = 1, -- Leaded Vial
		[5173] = 1, -- Deathweed
		k = "dp"
	},
	[9186] = { -- Mind-numbing Poison III
		[8925] = 1, -- Crystal Vial
		[8923] = 2, -- Essence of Agony
		[8924] = 2, -- Dust of Deterioration
		k = "mnp3", g = 5237
	},
	[6951] = { -- Mind-numbing Poison II
		[3372] = 1, -- Leaded Vial
		[2930] = 4, -- Essence of Pain
		[2928] = 4, -- Dust of Decay
		k = "mnp2", g = 5237
	},
	[5237] = { -- Mind-numbing Poison
		[3371] = 1, -- Empty Vial
		[2930] = 1, -- Essence of Pain
		[2928] = 1, -- Dust of Decay
		k = "mnp"
	},
	[3776] = { -- Crippling Poison II
		[8925] = 1, -- Crystal Vial
		[8923] = 3, -- Essence of Agony
		k = "cp2", g = 3775
	},
	[3775] = { -- Crippling Poison
		[3171] = 1, -- Empty Vial
		[2930] = 1, -- Essence of Pain
		k = "cp"
	},
	[5140] = { -- Flash Powder
		[5140] = 1, -- Yes... I know...
		k = "fp"
	},
}

function oTravi:OnEnable()
	self:RegisterEvent("MERCHANT_SHOW", function()
		if(self:IsPoisonVendor()) then
			local t = GetTradeSkillLine()
			if(t ~= "Poisons") then
			       D:Open(MerchantFrame, 'children', table, 'point', function(parent) return "TOP", "BOTTOM" end)
			else
			       D:Open(MerchantFrame, 'children', function() D:FeedAceOptionsTable(self:GenerateD()) end, 'point', function(parent) return "TOP", "BOTTOM" end)
			end 
		end
	end)
	self:RegisterEvent("MERCHANT_CLOSED", function()
		D:Close()
	end)
end

function oTravi:GenerateD()
	for k,v in pairs(poison) do
		local i, _, _, _, _, _, _, _, _, gi = GetItemInfo(v.g or k)
		
		if(i) then
			local t = string.gsub(i, " ", "")
			local n, _, _, l, _, _, _, _, _, pi = GetItemInfo(k)
			
			if(n and l <= UnitLevel("player")) then
				if(not table.args[t]) then
					table.args[t] = {
						name = i,
						type = "group",
						desc = i,
						icon = gi,
						args = {
						}
					}
				end
				table.args[t].args[v.k] = {
					name = n,
					type = "group",
					desc = n,
					icon = pi,
					args = {
						bh = {
							name = "Buy",
							type = "header",
							order = 100,
						},
						["b5"] = buy(i, 5, k),
						["b10"] = buy(i, 10, k),
						["b15"] = buy(i, 15, k),
						["b20"] = buy(i, 20, k),
						["b40"] = buy(i, 40, k),
						rh = {
							name = "Refill",
							type = "header",
							order = 200,
						},
						["r5"] = refill(i, 5, k),
						["r10"] = refill(i, 10, k),
						["r15"] = refill(i, 15, k),
						["r20"] = refill(i, 20, k),
						["r40"] = refill(i, 40, k),
					}
				}
			end
		end
	end
	return table
end

--[[ From PT
]]
function oTravi:GetID(item)
	if type(item) == "number" then return item
	elseif type(item) == "string" then
		local _, _, id = string.find(item, "item:(%d+):%d+:%d+:%d+")
		if id then return tonumber(id) end
	end
end

function oTravi:Buy(n, a,  b)
	for r,c in pairs(poison[n]) do
		for m=1,GetMerchantNumItems() do
			local _, _, price, num= GetMerchantItemInfo(m)
			local link = GetMerchantItemLink(m)
			if(self:GetID(link) == r) then
				local t
				if(b) then t = ((c/num)*a) - (self:ScanBags(r)/num)
				else t = ((c/num)*a) end
				while(t > 0) do
					local b = math.min(t, GetMerchantItemMaxStack(m))
					BuyMerchantItem(m, b)
					t = t - b
				end
			end
		end
	end
end

function oTravi:ScanBags(a1)
	local t, size, ilink, name = 0
	for b=0, 4 do
		size = GetContainerNumSlots(b)
		if(size > 0)then
			for s=1, size do
				ilink = GetContainerItemLink(b, s)
				if(ilink and self:GetID(ilink) == a1) then
					local _, c = GetContainerItemInfo(b, s)
					t = t + c
				end
			end
		end
	end
	return t
end

function oTravi:IsPoisonVendor()
	--[[ If you have a better solution to figuring it out, please say so. ]]
	for m=1,GetMerchantNumItems() do
		local link = GetMerchantItemLink(m)
		if(self:GetID(link) == 5140) then return true end
	end
	return false
end
